var __decorate = (this && this.__decorate) || function (decorators, target, key, desc) {
    var c = arguments.length, r = c < 3 ? target : desc === null ? desc = Object.getOwnPropertyDescriptor(target, key) : desc, d;
    if (typeof Reflect === "object" && typeof Reflect.decorate === "function") r = Reflect.decorate(decorators, target, key, desc);
    else for (var i = decorators.length - 1; i >= 0; i--) if (d = decorators[i]) r = (c < 3 ? d(r) : c > 3 ? d(target, key, r) : d(target, key)) || r;
    return c > 3 && r && Object.defineProperty(target, key, r), r;
};
var __metadata = (this && this.__metadata) || function (k, v) {
    if (typeof Reflect === "object" && typeof Reflect.metadata === "function") return Reflect.metadata(k, v);
};
var __param = (this && this.__param) || function (paramIndex, decorator) {
    return function (target, key) { decorator(target, key, paramIndex); }
};
import { Component, EventEmitter, Input, Output, TemplateRef, Inject, LOCALE_ID } from '@angular/core';
import { CalendarService } from './calendar.service';
export var Step;
(function (Step) {
    Step[Step["QuarterHour"] = 15] = "QuarterHour";
    Step[Step["HalfHour"] = 30] = "HalfHour";
    Step[Step["Hour"] = 60] = "Hour";
})(Step || (Step = {}));
var CalendarComponent = (function () {
    function CalendarComponent(calendarService, appLocale) {
        this.calendarService = calendarService;
        this.appLocale = appLocale;
        this.eventSource = [];
        this.calendarMode = 'month';
        this.formatDay = 'd';
        this.formatDayHeader = 'EEE';
        this.formatDayTitle = 'MMMM dd, yyyy';
        this.formatWeekTitle = 'MMMM yyyy, \'Week\' w';
        this.formatMonthTitle = 'MMMM yyyy';
        this.formatWeekViewDayHeader = 'EEE d';
        this.formatHourColumn = 'ha';
        this.showEventDetail = true;
        this.startingDayMonth = 0;
        this.startingDayWeek = 0;
        this.allDayLabel = 'all day';
        this.noEventsLabel = 'No Events';
        this.queryMode = 'local';
        this.step = Step.Hour;
        this.timeInterval = 60;
        this.autoSelect = true;
        this.locale = '';
        this.startHour = 0;
        this.endHour = 24;
        this.onCurrentDateChanged = new EventEmitter();
        this.onRangeChanged = new EventEmitter();
        this.onEventSelected = new EventEmitter();
        this.onTimeSelected = new EventEmitter();
        this.onTitleChanged = new EventEmitter();
        this.hourParts = 1;
        this.hourSegments = 1;
        this.locale = appLocale;
    }
    Object.defineProperty(CalendarComponent.prototype, "currentDate", {
        get: function () {
            return this._currentDate;
        },
        set: function (val) {
            if (!val) {
                val = new Date();
            }
            this._currentDate = val;
            this.calendarService.setCurrentDate(val, true);
            this.onCurrentDateChanged.emit(this._currentDate);
        },
        enumerable: true,
        configurable: true
    });
    CalendarComponent.prototype.ngOnInit = function () {
        var _this = this;
        if (this.autoSelect) {
            if (this.autoSelect.toString() === 'false') {
                this.autoSelect = false;
            }
            else {
                this.autoSelect = true;
            }
        }
        this.hourSegments = 60 / this.timeInterval;
        this.hourParts = 60 / this.step;
        if (this.hourParts <= this.hourSegments) {
            this.hourParts = 1;
        }
        else {
            this.hourParts = this.hourParts / this.hourSegments;
        }
        this.startHour = parseInt(this.startHour.toString(), 10);
        this.endHour = parseInt(this.endHour.toString(), 10);
        this.calendarService.queryMode = this.queryMode;
        this.currentDateChangedFromChildrenSubscription = this.calendarService.currentDateChangedFromChildren$.subscribe(function (currentDate) {
            _this._currentDate = currentDate;
            _this.onCurrentDateChanged.emit(currentDate);
        });
    };
    CalendarComponent.prototype.ngOnDestroy = function () {
        if (this.currentDateChangedFromChildrenSubscription) {
            this.currentDateChangedFromChildrenSubscription.unsubscribe();
            this.currentDateChangedFromChildrenSubscription = null;
        }
    };
    CalendarComponent.prototype.rangeChanged = function (range) {
        this.onRangeChanged.emit(range);
    };
    CalendarComponent.prototype.eventSelected = function (event) {
        this.onEventSelected.emit(event);
    };
    CalendarComponent.prototype.timeSelected = function (timeSelected) {
        this.onTimeSelected.emit(timeSelected);
    };
    CalendarComponent.prototype.titleChanged = function (title) {
        this.onTitleChanged.emit(title);
    };
    CalendarComponent.prototype.loadEvents = function () {
        this.calendarService.loadEvents();
    };
    CalendarComponent.prototype.next = function () {
        this.currentDate = this.calendarService.getAdjacentCalendarDate(this.calendarMode, 1);
    };
    CalendarComponent.prototype.previous = function () {
        this.currentDate = this.calendarService.getAdjacentCalendarDate(this.calendarMode, -1);
    };
    __decorate([
        Input(),
        __metadata("design:type", Date),
        __metadata("design:paramtypes", [Date])
    ], CalendarComponent.prototype, "currentDate", null);
    __decorate([
        Input(),
        __metadata("design:type", Array)
    ], CalendarComponent.prototype, "eventSource", void 0);
    __decorate([
        Input(),
        __metadata("design:type", String)
    ], CalendarComponent.prototype, "calendarMode", void 0);
    __decorate([
        Input(),
        __metadata("design:type", Object)
    ], CalendarComponent.prototype, "formatDay", void 0);
    __decorate([
        Input(),
        __metadata("design:type", Object)
    ], CalendarComponent.prototype, "formatDayHeader", void 0);
    __decorate([
        Input(),
        __metadata("design:type", Object)
    ], CalendarComponent.prototype, "formatDayTitle", void 0);
    __decorate([
        Input(),
        __metadata("design:type", Object)
    ], CalendarComponent.prototype, "formatWeekTitle", void 0);
    __decorate([
        Input(),
        __metadata("design:type", Object)
    ], CalendarComponent.prototype, "formatMonthTitle", void 0);
    __decorate([
        Input(),
        __metadata("design:type", Object)
    ], CalendarComponent.prototype, "formatWeekViewDayHeader", void 0);
    __decorate([
        Input(),
        __metadata("design:type", Object)
    ], CalendarComponent.prototype, "formatHourColumn", void 0);
    __decorate([
        Input(),
        __metadata("design:type", Object)
    ], CalendarComponent.prototype, "showEventDetail", void 0);
    __decorate([
        Input(),
        __metadata("design:type", Object)
    ], CalendarComponent.prototype, "startingDayMonth", void 0);
    __decorate([
        Input(),
        __metadata("design:type", Object)
    ], CalendarComponent.prototype, "startingDayWeek", void 0);
    __decorate([
        Input(),
        __metadata("design:type", Object)
    ], CalendarComponent.prototype, "allDayLabel", void 0);
    __decorate([
        Input(),
        __metadata("design:type", Object)
    ], CalendarComponent.prototype, "noEventsLabel", void 0);
    __decorate([
        Input(),
        __metadata("design:type", String)
    ], CalendarComponent.prototype, "queryMode", void 0);
    __decorate([
        Input(),
        __metadata("design:type", Number)
    ], CalendarComponent.prototype, "step", void 0);
    __decorate([
        Input(),
        __metadata("design:type", Object)
    ], CalendarComponent.prototype, "timeInterval", void 0);
    __decorate([
        Input(),
        __metadata("design:type", Object)
    ], CalendarComponent.prototype, "autoSelect", void 0);
    __decorate([
        Input(),
        __metadata("design:type", Function)
    ], CalendarComponent.prototype, "markDisabled", void 0);
    __decorate([
        Input(),
        __metadata("design:type", TemplateRef)
    ], CalendarComponent.prototype, "monthviewDisplayEventTemplate", void 0);
    __decorate([
        Input(),
        __metadata("design:type", TemplateRef)
    ], CalendarComponent.prototype, "monthviewEventDetailTemplate", void 0);
    __decorate([
        Input(),
        __metadata("design:type", TemplateRef)
    ], CalendarComponent.prototype, "weekviewHeaderTemplate", void 0);
    __decorate([
        Input(),
        __metadata("design:type", TemplateRef)
    ], CalendarComponent.prototype, "weekviewAllDayEventTemplate", void 0);
    __decorate([
        Input(),
        __metadata("design:type", TemplateRef)
    ], CalendarComponent.prototype, "weekviewNormalEventTemplate", void 0);
    __decorate([
        Input(),
        __metadata("design:type", TemplateRef)
    ], CalendarComponent.prototype, "dayviewAllDayEventTemplate", void 0);
    __decorate([
        Input(),
        __metadata("design:type", TemplateRef)
    ], CalendarComponent.prototype, "dayviewNormalEventTemplate", void 0);
    __decorate([
        Input(),
        __metadata("design:type", TemplateRef)
    ], CalendarComponent.prototype, "weekviewAllDayEventSectionTemplate", void 0);
    __decorate([
        Input(),
        __metadata("design:type", TemplateRef)
    ], CalendarComponent.prototype, "weekviewNormalEventSectionTemplate", void 0);
    __decorate([
        Input(),
        __metadata("design:type", TemplateRef)
    ], CalendarComponent.prototype, "dayviewAllDayEventSectionTemplate", void 0);
    __decorate([
        Input(),
        __metadata("design:type", TemplateRef)
    ], CalendarComponent.prototype, "dayviewNormalEventSectionTemplate", void 0);
    __decorate([
        Input(),
        __metadata("design:type", Object)
    ], CalendarComponent.prototype, "dateFormatter", void 0);
    __decorate([
        Input(),
        __metadata("design:type", Object)
    ], CalendarComponent.prototype, "locale", void 0);
    __decorate([
        Input(),
        __metadata("design:type", Object)
    ], CalendarComponent.prototype, "startHour", void 0);
    __decorate([
        Input(),
        __metadata("design:type", Object)
    ], CalendarComponent.prototype, "endHour", void 0);
    __decorate([
        Output(),
        __metadata("design:type", Object)
    ], CalendarComponent.prototype, "onCurrentDateChanged", void 0);
    __decorate([
        Output(),
        __metadata("design:type", Object)
    ], CalendarComponent.prototype, "onRangeChanged", void 0);
    __decorate([
        Output(),
        __metadata("design:type", Object)
    ], CalendarComponent.prototype, "onEventSelected", void 0);
    __decorate([
        Output(),
        __metadata("design:type", Object)
    ], CalendarComponent.prototype, "onTimeSelected", void 0);
    __decorate([
        Output(),
        __metadata("design:type", Object)
    ], CalendarComponent.prototype, "onTitleChanged", void 0);
    CalendarComponent = __decorate([
        Component({
            selector: 'calendar',
            template: "\n        <ng-template #monthviewDefaultDisplayEventTemplate let-view=\"view\" let-row=\"row\" let-col=\"col\">\n            {{view.dates[row * 7 + col].label}}\n        </ng-template>\n        <ng-template #monthviewDefaultEventDetailTemplate let-showEventDetail=\"showEventDetail\"\n                     let-selectedDate=\"selectedDate\" let-noEventsLabel=\"noEventsLabel\">\n            <div class=\"event-detail-container\" has-bouncing=\"false\" *ngIf=\"showEventDetail\" overflow-scroll=\"false\">\n                <div class=\"event-detail-item\" *ngFor=\"let event of selectedDate?.events\"\n                     (click)=\"eventSelected(event)\">\n                        <span *ngIf=\"!event.allDay\"\n                              class=\"monthview-eventdetail-timecolumn\">{{event.startTime | date: 'HH:mm'}}\n                            -\n                            {{event.endTime | date: 'HH:mm'}}\n                        </span>\n                    <span *ngIf=\"event.allDay\" class=\"monthview-eventdetail-timecolumn\">{{allDayLabel}}</span>\n                    <span class=\"event-detail\">  |  {{event.title}}</span>\n                </div>\n                <div class=\"event-detail-item\" *ngIf=\"selectedDate?.events.length==0\">\n                    <div class=\"no-events-label\">{{noEventsLabel}}</div>\n                </div>\n            </div>\n        </ng-template>\n        <ng-template #defaultWeekviewHeaderTemplate let-viewDate=\"viewDate\">\n            {{ viewDate.dayHeader }}\n        </ng-template>\n        <ng-template #defaultAllDayEventTemplate let-displayEvent=\"displayEvent\">\n            <div class=\"calendar-event-inner\">{{displayEvent.event.title}}</div>\n        </ng-template>\n        <ng-template #defaultNormalEventTemplate let-displayEvent=\"displayEvent\">\n            <div class=\"calendar-event-inner\">{{displayEvent.event.title}}</div>\n        </ng-template>\n        <ng-template #defaultWeekViewAllDayEventSectionTemplate let-day=\"day\" let-eventTemplate=\"eventTemplate\">\n            <div [ngClass]=\"{'calendar-event-wrap': day.events}\" *ngIf=\"day.events\"\n                 [ngStyle]=\"{height: 25*day.events.length+'px'}\">\n                <div *ngFor=\"let displayEvent of day.events\" class=\"calendar-event\" tappable\n                     (click)=\"eventSelected(displayEvent.event)\"\n                     [ngStyle]=\"{top: 25*displayEvent.position+'px', width: 100*(displayEvent.endIndex-displayEvent.startIndex)+'%', height: '25px'}\">\n                    <ng-template [ngTemplateOutlet]=\"eventTemplate\"\n                                 [ngTemplateOutletContext]=\"{displayEvent:displayEvent}\">\n                    </ng-template>\n                </div>\n            </div>\n        </ng-template>\n        <ng-template #defaultDayViewAllDayEventSectionTemplate let-allDayEvents=\"allDayEvents\"\n                     let-eventTemplate=\"eventTemplate\">\n            <div *ngFor=\"let displayEvent of allDayEvents; let eventIndex=index\"\n                 class=\"calendar-event\" tappable\n                 (click)=\"eventSelected(displayEvent.event)\"\n                 [ngStyle]=\"{top: 25*eventIndex+'px',width: '100%',height:'25px'}\">\n                <ng-template [ngTemplateOutlet]=\"eventTemplate\"\n                             [ngTemplateOutletContext]=\"{displayEvent:displayEvent}\">\n                </ng-template>\n            </div>\n        </ng-template>\n        <ng-template #defaultNormalEventSectionTemplate let-tm=\"tm\" let-hourParts=\"hourParts\"\n                     let-eventTemplate=\"eventTemplate\">\n            <div [ngClass]=\"{'calendar-event-wrap': tm.events}\" *ngIf=\"tm.events\">\n                <div *ngFor=\"let displayEvent of tm.events\" class=\"calendar-event\" tappable\n                     (click)=\"eventSelected(displayEvent.event)\"\n                     [ngStyle]=\"{top: (37*displayEvent.startOffset/hourParts)+'px',left: 100/displayEvent.overlapNumber*displayEvent.position+'%', width: 100/displayEvent.overlapNumber+'%', height: 37*(displayEvent.endIndex -displayEvent.startIndex - (displayEvent.endOffset + displayEvent.startOffset)/hourParts)+'px'}\">\n                    <ng-template [ngTemplateOutlet]=\"eventTemplate\"\n                                 [ngTemplateOutletContext]=\"{displayEvent:displayEvent}\">\n                    </ng-template>\n                </div>\n            </div>\n        </ng-template>\n\n        <div [ngSwitch]=\"calendarMode\" class=\"{{calendarMode}}view-container\">\n            <monthview *ngSwitchCase=\"'month'\"\n                       [formatDay]=\"formatDay\"\n                       [formatDayHeader]=\"formatDayHeader\"\n                       [formatMonthTitle]=\"formatMonthTitle\"\n                       [startingDayMonth]=\"startingDayMonth\"\n                       [showEventDetail]=\"showEventDetail\"\n                       [noEventsLabel]=\"noEventsLabel\"\n                       [autoSelect]=\"autoSelect\"\n                       [eventSource]=\"eventSource\"\n                       [markDisabled]=\"markDisabled\"\n                       [monthviewDisplayEventTemplate]=\"monthviewDisplayEventTemplate||monthviewDefaultDisplayEventTemplate\"\n                       [monthviewEventDetailTemplate]=\"monthviewEventDetailTemplate||monthviewDefaultEventDetailTemplate\"\n                       [locale]=\"locale\"\n                       [dateFormatter]=\"dateFormatter\"\n                       (onRangeChanged)=\"rangeChanged($event)\"\n                       (onEventSelected)=\"eventSelected($event)\"\n                       (onTimeSelected)=\"timeSelected($event)\"\n                       (onTitleChanged)=\"titleChanged($event)\">\n            </monthview>\n            <weekview *ngSwitchCase=\"'week'\"\n                      [formatWeekTitle]=\"formatWeekTitle\"\n                      [formatWeekViewDayHeader]=\"formatWeekViewDayHeader\"\n                      [formatHourColumn]=\"formatHourColumn\"\n                      [startingDayWeek]=\"startingDayWeek\"\n                      [allDayLabel]=\"allDayLabel\"\n                      [hourParts]=\"hourParts\"\n                      [autoSelect]=\"autoSelect\"\n                      [hourSegments]=\"hourSegments\"\n                      [eventSource]=\"eventSource\"\n                      [markDisabled]=\"markDisabled\"\n                      [weekviewHeaderTemplate]=\"weekviewHeaderTemplate||defaultWeekviewHeaderTemplate\"\n                      [weekviewAllDayEventTemplate]=\"weekviewAllDayEventTemplate||defaultAllDayEventTemplate\"\n                      [weekviewNormalEventTemplate]=\"weekviewNormalEventTemplate||defaultNormalEventTemplate\"\n                      [weekviewAllDayEventSectionTemplate]=\"weekviewAllDayEventSectionTemplate||defaultWeekViewAllDayEventSectionTemplate\"\n                      [weekviewNormalEventSectionTemplate]=\"weekviewNormalEventSectionTemplate||defaultNormalEventSectionTemplate\"\n                      [locale]=\"locale\"\n                      [dateFormatter]=\"dateFormatter\"\n                      [startHour]=\"startHour\"\n                      [endHour]=\"endHour\"\n                      (onRangeChanged)=\"rangeChanged($event)\"\n                      (onEventSelected)=\"eventSelected($event)\"\n                      (onTimeSelected)=\"timeSelected($event)\"\n                      (onTitleChanged)=\"titleChanged($event)\">\n            </weekview>\n            <dayview *ngSwitchCase=\"'day'\"\n                     [formatDayTitle]=\"formatDayTitle\"\n                     [formatHourColumn]=\"formatHourColumn\"\n                     [allDayLabel]=\"allDayLabel\"\n                     [hourParts]=\"hourParts\"\n                     [hourSegments]=\"hourSegments\"\n                     [eventSource]=\"eventSource\"\n                     [markDisabled]=\"markDisabled\"\n                     [dayviewAllDayEventTemplate]=\"dayviewAllDayEventTemplate||defaultAllDayEventTemplate\"\n                     [dayviewNormalEventTemplate]=\"dayviewNormalEventTemplate||defaultNormalEventTemplate\"\n                     [dayviewAllDayEventSectionTemplate]=\"dayviewAllDayEventSectionTemplate||defaultDayViewAllDayEventSectionTemplate\"\n                     [dayviewNormalEventSectionTemplate]=\"dayviewNormalEventSectionTemplate||defaultNormalEventSectionTemplate\"\n                     [locale]=\"locale\"\n                     [dateFormatter]=\"dateFormatter\"\n                     [startHour]=\"startHour\"\n                     [endHour]=\"endHour\"\n                     (onRangeChanged)=\"rangeChanged($event)\"\n                     (onEventSelected)=\"eventSelected($event)\"\n                     (onTimeSelected)=\"timeSelected($event)\"\n                     (onTitleChanged)=\"titleChanged($event)\">\n            </dayview>\n        </div>\n    ",
            styles: ["\n        :host > div {\n            height: 100%;\n        }\n\n        .event-detail-container {\n            border-top: 2px darkgrey solid;\n        }\n\n        .event-detail-item {\n            padding: 13px 0 13px 16px;\n            border-bottom: 1px #ddd solid;\n            cursor: pointer;\n        }\n\n        .no-events-label {\n            font-weight: bold;\n            color: darkgrey;\n            text-align: center;\n        }\n\n        .event-detail {\n            white-space: nowrap;\n            text-overflow: ellipsis;\n        }\n\n        .monthview-eventdetail-timecolumn {\n            width: 110px;\n            overflow: hidden;\n        }\n\n        .calendar-event-inner {\n            overflow: hidden;\n            background-color: #3a87ad;\n            color: white;\n            height: 100%;\n            width: 100%;\n            padding: 2px;\n            line-height: 15px;\n        }\n\n        @media (max-width: 750px) {\n            .calendar-event-inner {\n                font-size: 12px;\n            }\n        }\n    "],
            providers: [CalendarService]
        }),
        __param(1, Inject(LOCALE_ID)),
        __metadata("design:paramtypes", [CalendarService, String])
    ], CalendarComponent);
    return CalendarComponent;
}());
export { CalendarComponent };
//# sourceMappingURL=calendar.js.map